<?php
namespace EMS\PortalFuncionario\Geral\Repository;

use Zeedhi\Framework\Controller\Crud;
use Doctrine\ORM\EntityManager;

class DemonstrativoPagamentoRepository extends Crud {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getDemonstrativoPagamento(string $nrorg, string $nrvinculom, string $dtmescompetenc, string $nrtipomoviment, string $nrtpmodalidcal, string $ocorrecal, string $ignoraocorr) : array {
        try {
            $sql = <<<SQL
                SELECT
                    TO_CHAR(CF.DTOCORRENCIA, 'DD/MM/YYYY') AS DTMESCOMPETENC,
                    ICF.NREVENTOM,
                    ROUND(DECODE(ICF.VRREFFOLHA, 0, NULL, ICF.VRREFFOLHA), 2) AS VRREFFOLHA,
                    ROUND(ICF.VREVENTOFOLHA, 2) AS VREVENTOFOLHA,
                    CASE
                        WHEN ICF.NREVENTOM = 2020
                            OR ICF.NREVENTOM = 2010 THEN
                            EH.NMEVENTOH || ' Mês'
                        ELSE
                            EH.NMEVENTOH
                    END NMEVENTOH,
                    CASE
                        WHEN ICF.NREVENTOM = 3010 THEN
                            'TOTAL'/*'PROVENTO'*/
                        WHEN ICF.NREVENTOM = 3020      THEN
                            'TOTAL'/*'DESCONTO'*/
                        WHEN ICF.NREVENTOM = 3030      THEN
                            'TOTAL'/*'LIQUIDO'*/
                        WHEN ICF.NREVENTOM = 2020
                            OR ICF.NREVENTOM = 2010 THEN
                            'BASE'
                        WHEN EM.IDTIPOEVENTO = 'TOTAL' THEN
                            'BASE'
                        ELSE
                            EM.IDTIPOEVENTO
                    END IDTIPOEVENTO,
                    CASE
                        WHEN ICF.NREVENTOM = 3010 THEN
                            'Z_PROVENTO'
                        WHEN ICF.NREVENTOM = 3020 THEN
                            'Y_DESCONTO'
                        WHEN ICF.NREVENTOM = 3030 THEN
                            'X_LIQUIDO'
                        ELSE
                            NULL
                    END ORDER_ITENS
                FROM
                    FPA_ITECALCFOLHA   ICF
                    JOIN FPA_CALCULOFOLHA   CF ON CF.NRORG = ICF.NRORG
                                                AND CF.NRCALCULOFOLHA = ICF.NRCALCULOFOLHA
                                                AND CF.NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT
                                                AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                                                AND CF.DTOCORRENCIA = TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                AND ( CF.NROCORRECAL = :P_OCORRECAL
                                                    OR :P_IGNORAOCORR = 'S' ) --Eventos
                    JOIN FPA_EVENTOM        EM ON EM.NREVENTOM = ICF.NREVENTOM
                                        AND ( EM.IDTIPOEVENTO IN (
                        'PROVENTO',
                        'DESCONTO'
                    )
                    OR ICF.NREVENTOM IN (/*TOTAIS*/
                        3010,
                        3020,
                        3030, /*INNS*/
                        3070,
                        3130, /*FGTS*/
                        3060,
                        3120, /*IRRF*/
                        3140,
                        3080, /*ENCARGOS_FGTS*/
                        2020,
                        2010
                    ) )
                    JOIN FPA_EVENTOH        EH ON EH.NREVENTOM = EM.NREVENTOM
                                        AND EH.IDIMPRESSEVENTO = 'S'
                WHERE
                    ICF.NRORG = :P_NRORG
                    AND ICF.NRVINCULOM = :P_NRVINCULOM
                    AND ICF.IDEVENDEMONCALC = 'N' --Eventos
                    AND EH.DTMESCOMPETENC = (
                        SELECT
                            MAX(DTMESCOMPETENC)
                        FROM
                            FPA_EVENTOH
                        WHERE
                            DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                            AND NREVENTOM = EM.NREVENTOM
                            AND IDIMPRESSEVENTO = 'S'
                    )
                    AND EXISTS (
                        SELECT
                            1
                        FROM
                            FPA_ITECALCFOLHA   ITE
                            JOIN FPA_CALCULOFOLHA   CALC ON CALC.NRCALCULOFOLHA = ITE.NRCALCULOFOLHA
                                                        AND CALC.NRORG = ITE.NRORG
                        WHERE
                            ITE.NRORG = ICF.NRORG
                            AND ITE.NRVINCULOM = ICF.NRVINCULOM
                            AND ITE.NRCALCULOFOLHA = ICF.NRCALCULOFOLHA
                            AND ( ( ITE.NREVENTOM = 3035
                                                AND CALC.NRTIPOMOVIMENT IN (1, 2, 4, 10, 19) )
                                OR ( ITE.NREVENTOM = 3030
                                    AND CALC.NRTIPOMOVIMENT NOT IN (1, 2, 4, 10, 19) ) )
                    ) /*retorna somente quando existir o evento de fechamento de folha mensal*/
                ORDER BY
                    ORDER_ITENS DESC,
                    IDTIPOEVENTO DESC,
                    EH.NRORDIMPRESEVEN
SQL;
            $query = $this->entityManager->getConnection()->prepare($sql);

            $query->execute(
                array(
                    "P_NRTIPOMOVIMENT"  => $nrtipomoviment,
                    "P_NRTPMODALIDCAL"  => $nrtpmodalidcal,
                    "P_DTMESCOMPETENC"  => $dtmescompetenc,
                    "P_OCORRECAL"       => $ocorrecal,
                    "P_IGNORAOCORR"     => $ignoraocorr,
                    "P_NRORG"           => $nrorg,
                    "P_NRVINCULOM"      => $nrvinculom
                )
            );
            
            return $query->fetchAll();
        } catch (\Exception $e) {
            throw $e;
        }
    }

}